/*
 * $Id$
 */

package org.codehaus.mojo.appassembler.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class JvmSettings implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field initialMemorySize
     */
    private String initialMemorySize;

    /**
     * Field maxMemorySize
     */
    private String maxMemorySize;

    /**
     * Field maxStackSize
     */
    private String maxStackSize;

    /**
     * Field systemProperties
     */
    private java.util.List systemProperties;

    /**
     * Field extraArguments
     */
    private java.util.List extraArguments;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addExtraArgument
     * 
     * @param string
     */
    public void addExtraArgument(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "JvmSettings.addExtraArguments(string) parameter must be instanceof " + String.class.getName() );
        }
        getExtraArguments().add( string );
    } //-- void addExtraArgument(String) 

    /**
     * Method addSystemProperty
     * 
     * @param string
     */
    public void addSystemProperty(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "JvmSettings.addSystemProperties(string) parameter must be instanceof " + String.class.getName() );
        }
        getSystemProperties().add( string );
    } //-- void addSystemProperty(String) 

    /**
     * Method getExtraArguments
     */
    public java.util.List getExtraArguments()
    {
        if ( this.extraArguments == null )
        {
            this.extraArguments = new java.util.ArrayList();
        }
        
        return this.extraArguments;
    } //-- java.util.List getExtraArguments() 

    /**
     * Get null
     */
    public String getInitialMemorySize()
    {
        return this.initialMemorySize;
    } //-- String getInitialMemorySize() 

    /**
     * Get null
     */
    public String getMaxMemorySize()
    {
        return this.maxMemorySize;
    } //-- String getMaxMemorySize() 

    /**
     * Get null
     */
    public String getMaxStackSize()
    {
        return this.maxStackSize;
    } //-- String getMaxStackSize() 

    /**
     * Method getSystemProperties
     */
    public java.util.List getSystemProperties()
    {
        if ( this.systemProperties == null )
        {
            this.systemProperties = new java.util.ArrayList();
        }
        
        return this.systemProperties;
    } //-- java.util.List getSystemProperties() 

    /**
     * Method removeExtraArgument
     * 
     * @param string
     */
    public void removeExtraArgument(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "JvmSettings.removeExtraArguments(string) parameter must be instanceof " + String.class.getName() );
        }
        getExtraArguments().remove( string );
    } //-- void removeExtraArgument(String) 

    /**
     * Method removeSystemProperty
     * 
     * @param string
     */
    public void removeSystemProperty(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "JvmSettings.removeSystemProperties(string) parameter must be instanceof " + String.class.getName() );
        }
        getSystemProperties().remove( string );
    } //-- void removeSystemProperty(String) 

    /**
     * Set null
     * 
     * @param extraArguments
     */
    public void setExtraArguments(java.util.List extraArguments)
    {
        this.extraArguments = extraArguments;
    } //-- void setExtraArguments(java.util.List) 

    /**
     * Set null
     * 
     * @param initialMemorySize
     */
    public void setInitialMemorySize(String initialMemorySize)
    {
        this.initialMemorySize = initialMemorySize;
    } //-- void setInitialMemorySize(String) 

    /**
     * Set null
     * 
     * @param maxMemorySize
     */
    public void setMaxMemorySize(String maxMemorySize)
    {
        this.maxMemorySize = maxMemorySize;
    } //-- void setMaxMemorySize(String) 

    /**
     * Set null
     * 
     * @param maxStackSize
     */
    public void setMaxStackSize(String maxStackSize)
    {
        this.maxStackSize = maxStackSize;
    } //-- void setMaxStackSize(String) 

    /**
     * Set null
     * 
     * @param systemProperties
     */
    public void setSystemProperties(java.util.List systemProperties)
    {
        this.systemProperties = systemProperties;
    } //-- void setSystemProperties(java.util.List) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
